WAIT_FOR_TEST_CREATED = 300


class VariableItem:
    def __init__(self, name, mandatory=True, default=None):
        self.Name = name
        self.Default = default
        self.Mandatory = mandatory

    @property
    def as_tuple(self):
        return self.Name, self.Mandatory, self.Default


PRACTI_TEST_VARIABLES = [
    VariableItem('PT_ENABLED', False, False),
    # VariableItem('PT_TEST_CREATION_METHOD', False, 'at_runtime'),
    VariableItem('PT_DEBUG', False, False),
    VariableItem('PT_PROJECT_NAME'),
    VariableItem('PT_USER_NAME'),
    VariableItem('PT_USER_NAME_EMAIL'),
    VariableItem('PT_USER_TOKEN'),
    VariableItem('PT_ENDPOINT', False),
    VariableItem('PT_VERSION'),
    VariableItem('PT_TEST_SET_LEVEL', False, 0),
    VariableItem('PT_TEST_NAME_LEVEL', False, 1),
    VariableItem('PT_TEST_TAG', False, {'prefix': 'Test-'}),
    VariableItem('PT_FIELD_PREFIX', False, {'refix': 'Custom-', 'delimiter': '-'}),
    VariableItem('PT_FIELDS_MAP'),
    VariableItem('TEST_FIELDS'),
    VariableItem('INSTANCE_FIELDS'),
    VariableItem('TEST_SET_FIELDS'),
    VariableItem('PT_FOREGROUND', False, True),
    VariableItem('PT_EXTERNAL_RUN_ID', False),
    VariableItem('TAG_MAPPING'),
]


def get_default_value(name):
    for var in [v for v in PRACTI_TEST_VARIABLES if v.Name == name]:
        return var.Default
    raise AttributeError(f"Variable '{name}' is unknown")